/*
PeRdr - PE file disassembler
Copyright (C) 1999-2002 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#include "global.h"
#ifdef HAVE_HDRSTOP
#pragma hdrstop
#endif

#include <algorithm>
#include <iostream>
#include "api.h"
#include "apicache.h"

using namespace std;

// !!! sebbene il costruttore sia vuoto e' bene non renderlo inline
Api::Api()
{
}


pair<Api::iterator,Api::iterator> Api::operator[](vma_t address) const
{
  iterator begin = api.lower_bound(ApiPair(address,""));
  iterator end   = begin;
  
  // usually do one loop, so do not use strange method
  for(; end != api.end() ; ++end)
    if ( (*end).address != address )
      break;
  _PRG_ASSERT( begin == api.end() || (*begin).address >= address );
  _DEBUG_(iterator tmp = begin);
  _PRG_ASSERT( tmp == api.begin() || (*--tmp).address < address );
  _PRG_ASSERT( end == api.end() || begin == end || (*end).address > address );
  if( end == api.end() || begin == end || (*end).address > address ) ;
    else { cerr << "Address=" << address << " end Address=" << (*end).address << " end Name=" << (*end).api << endl; _PRG_ASSERT(0); }
  _DEBUG_( tmp = end );
  _PRG_ASSERT( tmp == api.begin() || begin == end || (*--tmp).address == address );
  return pair<iterator,iterator>(begin,end);
}

bool Api::IsValid(vma_t address) const
{
  pair<iterator,iterator> apis = (*this)[address];
  if ( apis.first != apis.second )
  	return true;
  return false;
}

void Api::insert(const std::string& name,vma_t address)
{
	api.insert(ApiPair(address,name));
}

vma_t Api::GetNextValid(vma_t address) const
{
  iterator i = api.lower_bound(ApiPair(address+1,""));
  if ( i == api.end() )
    return 0;
  _PRG_ASSERT( (*i).address > address );
  return (*i).address;
}

void ApiAddImport(uint32_t address,uint32_t hint,const char* dll_name,const char* func_name,void* param)
{
  if (address != 0)
  {
  	ApiAddImportParam *p = (ApiAddImportParam*)param;
    char s[10]; // !!! constant
    std::string name(dll_name);
    name += ".";
    if (func_name != NULL)
      name += func_name;
    else
    {
      // name += itoa(hint,s,10);
      sprintf(s,"%i",hint);
      name += s; //itoa(hint,s,10);
      
      std::string fullName;
      if (ApiCache::GetFullApiName(fullName,dll_name,hint))
      {
        name += " (";
	name += fullName;
	name += ")";
      }
    }
    p->api->insert(name,address+p->imageBase);
  }
}

