#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>

using namespace std;

#include "dump.hpp"

static char test[] = 
  "Questo e' un test di prova di cui verra' eseguito il dump"
  "di seguito un po' di roba a caso... dgfklhfdglkfhgljkfhg"
  "fdkljhgfldkhdlkjglbnmblkhpkweyuiqw09723483764lkdhjlbkfhj"
  "flkjblkbmourgoirug+pojbvlmblvjbpougf+pogulfjgfdljgf";
#define LENTEST (sizeof(test)/sizeof(test[0])-1)

// interface to dump
class TstDumpStream: public DumpStream
{
private:
	int pos;
public:
	TstDumpStream():pos(0) {};
	
	// read sz bytes
	// return bytes currently readed
	virtual long Read(unsigned char* dest,size_t sz)
	{
		// wrong pos ??
		if (pos < 0 || pos > LENTEST)
			return -1;
		int left = LENTEST - pos;
		if (left > sz)
			left = sz;
		memcpy(dest,test+pos,left);
		pos += left;
		return left;
	}

	// move pointer by diff (positive or negative)
	// return bytes moved
	virtual int Seek(int diff)
	{
		int prev = pos;
		pos += diff;
		if (pos < 0)
			pos = 0;
		if (pos > LENTEST)
			pos = LENTEST;
		return pos-prev;
	}

	// get max position in character, not counting terminator
	virtual size_t GetMaxPosLen()
	{
		return 8;
	}

	// get visible position
	// return char written, not counting terminator
	virtual size_t GetPos(char* buf)
	{
		sprintf(buf,"%08X",pos);
		return 8;
	}

	// get scroll stat
	// position and size in bytes
	virtual void GetScroll(unsigned long& pos,unsigned long& size)
	{
		pos = this->pos;
		size = LENTEST;
	}

	// scroll giving scroll pos
	virtual void SetScrollPos(unsigned long _pos)
	{
		pos = _pos;
		if (pos < 0)
			pos = 0;
		if (pos > LENTEST)
			pos = LENTEST;
	}
};

DumpStream* CreateSimpleDumpStream()
{
	return new TstDumpStream();
}


