/*
PeRdr - PE file disassembler
Copyright (C) 1999-2002 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
/*
opzioni:
corta: un carattere
 tipi: booleano (senza parametro), con parametro, se con parametro deve essere l'ultimo
lunga: piu' caratteri, puo' essere la stessa di un carattere solo

opzione carattere/i singoli \0 stringhe (opzioni lunghe) \0
tipo (booleano, stringa)
puntatore a dato
*/
#include <cstdlib>
#include <cctype>
#include <cstring>
#include "utils/bitcompat.h"
#include "options.h"

// ritorna indica parametro se risultato ok
// ritorna -indice se parametro sconosciuto
int get_options(int argc, char** argv,option* opttable)
{
  option *opt;
  char *p, *next_char;
  // prima non opzione e inizio indice opzioni
  int optind, optno, optfirstind;
  optno = optind = 1;
  for ( ; optind<argc; )
  {
    // se non e' un'opzione ritorna
    while( argv[optind][0] != '-' )
      if ( ++optind == argc )
        return optno;

    optfirstind = optind;

    if ( argv[optind][1] == '-' )
    {
      // caso '--' ritorna indica successivo elemento
      if (argv[optind][2] == '\0' )
        return optind+1;
      for(opt = opttable; ; ++opt)
      {
        if ( opt->names == NULL )
            return -optind;
        p = opt->names;

        // caso parametri lunghi
        for( ;*(p=p+strlen(p)+1); )
        {
          int l = strlen(p);
          if ( strncmp(p,argv[optind]+2,l) == 0 )
          {
            next_char = &argv[optind][2+l];
            if ( opt->type != optionBool && *next_char == '=' )
            {
              // --arg=value
              p = next_char+1;
              goto param_value;
            }
            // prova con un'altra opzione
            if (*next_char != '\0')
              break;
            if ( opt->type == optionBool)
              goto param_value;
            // --arg value
            goto param_found;
          }
        }
      }
      // non raggiunge mai questo punto
    }
    else
    {
      for(p = argv[optind]+1; *p != '\0' ;++p)
      {
        for( opt = opttable; ; ++opt)
        {
          if ( opt->names == NULL )
            return -optind;

          // caso parametri a caratteri singoli
          if ( strchr(opt->names,*p) != NULL )
          {
            if ( opt->type != optionBool )
            {
              // -a value
              next_char = p+1;
              goto param_found;
            }
            *(bool*)(opt->val) = true;
            break;
          }
        }
      }
      goto option_found;
    }

param_found:
    // il valore dell'opzione e' il successivo parametro
    if (*next_char != '\0' || ++optind == argc)
      return -optind;
    p = argv[optind];
param_value:
    // scrivi dati in output
    switch(opt->type)
    {
      case optionBool:
        *(bool*)(opt->val) = true;
        break;
      case optionString:
        *(const char**)(opt->val) = p;
        break;
      case optionLong:
        {
        char *pend;
        if ( !isdigit(*p) )
          return -optind;
        *(long*)(opt->val) = strtol(p,&pend,0);
        if ( *pend != '\0' )
          return -optind;
        }
      break;
    }

option_found:
    ++optind;
    // sposta in fondo gli argomenti non flag
    if (optfirstind != optno)
    {
      // shifta num volte opzioni all'inizio
      for (;optind != optfirstind;)
      {
        int n = optfirstind;
        char *temp = argv[n];
        for(;--n >= optno;)
          argv[n+1] = argv[n];
        argv[optno] = temp;
        ++optno;
        ++optfirstind;
      }
    }
    else
      optno = optind;

  }
  return optno;
}
