/*
PeRdr - PE file disassembler
Copyright (C) 1999-2002 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#include "global.h"
#ifdef HAVE_HDRSTOP
#pragma hdrstop
#endif

#include "options.h"
#include "perdroptions.h"

PeRdrOption options = {
  false, // showBytes
  false, // disableP3
  false, // disable3DNow
  false, // disableEnh3DNow
  false, // showVersion
  false, // showHelp
  false, // showPriority
  false, // rawDumping
  false, // extractIconRes
  false, // showHeaders
  false, // showImports
  false, // showRelocations
  false, // showExports
  false, // showResources
  false  // showCode
};

static option allOptions[] =
{
  { "b\0bytes\0",                &options.showBytes,       optionBool },
  { "\0disable-3dnow\0",         &options.disable3DNow,    optionBool },
  { "\0disable-enh3dnow\0",      &options.disableEnh3DNow, optionBool },
  { "\0disable-pentium3\0",      &options.disableP3,       optionBool },
  { "\0disable-athlon\0",        &options.disableAthlon,   optionBool },
  { "\0version\0",               &options.showVersion,     optionBool },
  { "\0help\0",                  &options.showHelp,        optionBool },
  { "\0show-priority\0",         &options.showPriority,    optionBool },
  { "\0raw-dump\0",              &options.rawDumping,      optionBool },
  { "\0extract-icon-resource\0", &options.extractIconRes,  optionBool },
  { "\0show-headers\0",          &options.showHeaders,     optionBool },
  { "\0show-imports\0",          &options.showImports,     optionBool },
  { "\0show-relocations\0",      &options.showRelocations, optionBool },
  { "\0show-exports\0",          &options.showExports,     optionBool },
  { "\0show-resources\0",        &options.showResources,   optionBool },
  { "\0show-code\0",             &options.showCode,        optionBool },
  { NULL,                        NULL,                     optionBool }
};

int ReadOptions(int argc,char** argv)
{
  // !!! use GNU getopt_long instead !!!
  int res = get_options(argc,argv,allOptions);

  // adjust option
  if (options.disable3DNow)
    options.disableEnh3DNow = true;

  if (!options.showHeaders && !options.showImports && !options.showRelocations 
		  && !options.showExports && !options.showCode
		  && !options.showResources)
  {
    options.showHeaders = true;
    options.showImports = true;
    options.showRelocations = true;
    options.showExports = true;
    options.showCode = true;
    options.showResources = true;
  }
	    
  return res;
}
