/*
PeRdr - PE file disassembler
Copyright (C) 1999-2002 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#include "global.h"
#pragma hdrstop

#include <stdexcept>
#include "x86istr.h"
#include "x86dasm.h"
#ifdef DEBUG
#include <cctype>
#endif
#include "utils/f77auto_ptr"

using namespace std;

static unsigned char buffer[128];
static size_t pos = 0;
static size_t buflen = 0;

int read_byte()
{
  if (pos < 0 || pos >= buflen)
    return -1;
  return buffer[pos++];
}

// !!! bella questa aggiunta...
void unread_bytes(int n)
{
  if (pos < n)
    throw runtime_error("bad unread !!!");
}

void WriteInstruction(const Instruction& instruction)
{
  char buffer[80];
  instruction.Write(buffer);
  printf("%s\n",buffer);
}

RelocationInfos infos;

int GetInstruction(vma_t address,const unsigned char* code,size_t len,Instruction& instruction)
{
  // copia nel buffer per leggere l'istruzione data
  if (code)
  {
    memcpy(buffer,code,len);
    buflen = len;
    pos = 0;
  }

  // legge l'istruzione
  InstructionDecoder decoder(infos);
  return decoder.Decode(instruction,address);
}

int main()
{
  Instruction instr;

  if (GetInstruction(0x401000,(unsigned char*)"pippo",5,instr))
    WriteInstruction(instr);

  if (GetInstruction(0x401000,(unsigned char*)"\x0f\xb6\x40\x83",4,instr))
    WriteInstruction(instr);

  if (GetInstruction(0x401000,(unsigned char*)"\x0f\xb7\x40\x83",4,instr))
    WriteInstruction(instr);

  if (GetInstruction(0x401000,(unsigned char*)"\x0f\xbe\xc1",3,instr))
    WriteInstruction(instr);

  return 0;
}
